// MTE MK1 (la Churrera) v5.0
// Copyleft 2010-2014, 2020 by the Mojon Twins

// levelset.h

// Contains this game's level sequence.
// Format is different for 128K games (using level bundles)
// and 48 games (using separate assets).

#ifdef MODE_128K
	// 128K format:
	typedef struct {
		unsigned char resource_id;
		unsigned char music_id;
		#ifdef ACTIVATE_SCRIPTING
			unsigned int script_offset;
		#endif
	} LEVEL;
#else
	// 48K format:
	typedef struct {
		// unsigned char map_w, map_h;
		// unsigned char scr_ini, ini_x, ini_y;
		// unsigned char max_objs;
		unsigned char *c_map_bolts;
		#ifdef PER_LEVEL_TILESET
			// unsigned char *c_tileset;
		#endif
		unsigned char *c_enems_hotspots;
		// unsigned char *c_behs;
		#ifdef PER_LEVEL_SPRITESET
			// unsigned char *c_sprites;
		#endif
		#ifdef ACTIVATE_SCRIPTING
			// unsigned int script_offset;
		#endif
		// unsigned char music_id;
	} LEVEL;
#endif

// Include here your compressed binaries:

// MAPAS
extern unsigned char map_0 [0];
extern unsigned char map_1 [0];
extern unsigned char map_1a [0];
extern unsigned char map_2 [0];
extern unsigned char map_2a [0];
extern unsigned char map_3 [0];
extern unsigned char map_4 [0];
extern unsigned char map_5 [0];
extern unsigned char map_5b [0];
extern unsigned char map_6 [0];
extern unsigned char map_7 [0];
extern unsigned char map_8 [0];
extern unsigned char map_9 [0];
extern unsigned char map_9 [0];
extern unsigned char map_10 [0];
extern unsigned char map_10b [0];
extern unsigned char map_11 [0];
extern unsigned char map_12 [0];
extern unsigned char map_13 [0];
extern unsigned char map_14 [0];
extern unsigned char map_15 [0];
extern unsigned char map_16 [0];
extern unsigned char map_17 [0];
extern unsigned char map_18 [0];
extern unsigned char map_19 [0];
extern unsigned char map_20 [0];
extern unsigned char map_20b [0];
extern unsigned char map_21 [0];
extern unsigned char map_22 [0];
extern unsigned char map_23 [0];
extern unsigned char map_24 [0];
extern unsigned char map_25 [0];
extern unsigned char map_26 [0];
extern unsigned char map_27 [0];
extern unsigned char map_28 [0];
extern unsigned char map_29 [0];
extern unsigned char map_30 [0];
extern unsigned char map_30b [0];
extern unsigned char map_31 [0];
extern unsigned char map_32 [0];
extern unsigned char map_33 [0];
extern unsigned char map_34 [0];
extern unsigned char map_35 [0];
extern unsigned char map_36 [0];
extern unsigned char map_37 [0];
extern unsigned char map_38 [0];
extern unsigned char map_39 [0];
extern unsigned char map_40 [0];

#asm
	._map_0
	BINARY "../bin/screen0c.bin"	
	._map_1
	BINARY "../bin/screen1c.bin"
	._map_1a
	BINARY "../bin/screen1ac.bin"		
	._map_2
	BINARY "../bin/screen2c.bin"
	._map_2a
	BINARY "../bin/screen2ac.bin"	
	._map_3
	BINARY "../bin/screen3c.bin"	
	._map_4
	BINARY "../bin/screen4c.bin"	
	._map_5
	BINARY "../bin/screen5c.bin" 
	._map_5b
	BINARY "../bin/screen5bc.bin" // Bonus 1	
	._map_6
	BINARY "../bin/screen6c.bin"	
	._map_7
	BINARY "../bin/screen7c.bin"	
	._map_8
	BINARY "../bin/screen9c.bin"	
	._map_9
	BINARY "../bin/screen8c.bin"
	._map_10
	BINARY "../bin/screen10c.bin" 
	._map_10b
	BINARY "../bin/screen10bc.bin" // Bonus 2
	._map_11
	BINARY "../bin/screen11c.bin"
	._map_12
	BINARY "../bin/screen12c.bin"
	._map_13
	BINARY "../bin/screen13c.bin"
	._map_14
	BINARY "../bin/screen14c.bin"
	._map_15
	BINARY "../bin/screen15c.bin"
	._map_16
	BINARY "../bin/screen16c.bin"
	._map_17
	BINARY "../bin/screen17c.bin"
	._map_18
	BINARY "../bin/screen18c.bin"
	._map_19
	BINARY "../bin/screen19c.bin"
	._map_20
	BINARY "../bin/screen20c.bin"
	._map_20b
	BINARY "../bin/screen20bc.bin" // Bonus 3
	._map_21
	BINARY "../bin/screen21c.bin"
	._map_22
	BINARY "../bin/screen22c.bin"
	._map_23
	BINARY "../bin/screen23c.bin"
	._map_24
	BINARY "../bin/screen24c.bin"
	._map_25
	BINARY "../bin/screen25c.bin"
	._map_26
	BINARY "../bin/screen26c.bin"
	._map_27
	BINARY "../bin/screen27c.bin"
	._map_28
	BINARY "../bin/screen28c.bin"
	._map_29
	BINARY "../bin/screen29c.bin"
	._map_30
	BINARY "../bin/screen30c.bin"
	._map_30b
	BINARY "../bin/screen30bc.bin" // Bonus 4
	._map_31
	BINARY "../bin/screen31c.bin"
	._map_32
	BINARY "../bin/screen32c.bin"
	._map_33
	BINARY "../bin/screen33c.bin"
	._map_34
	BINARY "../bin/screen34c.bin"
	._map_35
	BINARY "../bin/screen35c.bin"
	._map_36
	BINARY "../bin/screen36c.bin"
	._map_37
	BINARY "../bin/screen37c.bin"

		
#endasm	


// ENEMIGOS
extern unsigned char ene0 [0];
extern unsigned char ene1 [0];
extern unsigned char ene1a [0];
extern unsigned char ene2 [0];
extern unsigned char ene2a [0];
extern unsigned char ene3 [0];
extern unsigned char ene4 [0];
extern unsigned char ene5 [0];
extern unsigned char ene6 [0];
extern unsigned char ene7 [0];
extern unsigned char ene8 [0];
extern unsigned char ene9 [0];
extern unsigned char ene10 [0];
extern unsigned char ene11 [0];
extern unsigned char ene12 [0];
extern unsigned char ene13 [0];
extern unsigned char ene14 [0];
extern unsigned char ene15 [0];
extern unsigned char ene16 [0];
extern unsigned char ene17 [0];
extern unsigned char ene18 [0];
extern unsigned char ene19 [0];
extern unsigned char ene20 [0];
extern unsigned char ene21 [0];
extern unsigned char ene22 [0];
extern unsigned char ene23 [0];
extern unsigned char ene24 [0];
extern unsigned char ene25 [0];
extern unsigned char ene26 [0];
extern unsigned char ene27 [0];
extern unsigned char ene28 [0];
extern unsigned char ene29 [0];
extern unsigned char ene30 [0];
extern unsigned char ene31 [0];
extern unsigned char ene32 [0];
extern unsigned char ene33 [0];
extern unsigned char ene34 [0];
extern unsigned char ene35 [0];
extern unsigned char ene36 [0];
extern unsigned char ene37 [0];

extern unsigned char ene_bonus [0];
#asm	
		._ene0
	BINARY "../bin/ene0c.bin"
		._ene1
	BINARY "../bin/ene1c.bin"
		._ene1a
	BINARY "../bin/ene1ac.bin"
		._ene2
	BINARY "../bin/ene2c.bin"
		._ene2a
	BINARY "../bin/ene2ac.bin"
		._ene3
	BINARY "../bin/ene3c.bin"
		._ene4
	BINARY "../bin/ene4c.bin"
		._ene5
	BINARY "../bin/ene5c.bin"
		._ene6
	BINARY "../bin/ene6c.bin"
		._ene7
	BINARY "../bin/ene7c.bin"
		._ene8
	BINARY "../bin/ene9c.bin"
		._ene9
	BINARY "../bin/ene8c.bin"
		._ene10
	BINARY "../bin/ene10c.bin"
		._ene11
	BINARY "../bin/ene11c.bin"
		._ene12
	BINARY "../bin/ene12c.bin"
		._ene13
	BINARY "../bin/ene13c.bin"
		._ene14
	BINARY "../bin/ene14c.bin"
		._ene15
	BINARY "../bin/ene15c.bin"
		._ene16
	BINARY "../bin/ene16c.bin"
		._ene17
	BINARY "../bin/ene17c.bin"
		._ene18
	BINARY "../bin/ene18c.bin"
		._ene19
	BINARY "../bin/ene19c.bin"
		._ene20
	BINARY "../bin/ene20c.bin"
		._ene21
	BINARY "../bin/ene21c.bin"
		._ene22
	BINARY "../bin/ene22c.bin"
		._ene23
	BINARY "../bin/ene23c.bin"
		._ene24
	BINARY "../bin/ene24c.bin"
		._ene25
	BINARY "../bin/ene25c.bin"
		._ene26
	BINARY "../bin/ene26c.bin"
		._ene27
	BINARY "../bin/ene27c.bin"
		._ene28
	BINARY "../bin/ene28c.bin"
		._ene29
	BINARY "../bin/ene29c.bin"
		._ene30
	BINARY "../bin/ene30c.bin"
		._ene31
	BINARY "../bin/ene31c.bin"
		._ene32
	BINARY "../bin/ene32c.bin"
		._ene33
	BINARY "../bin/ene33c.bin"
		._ene34
	BINARY "../bin/ene34c.bin"
		._ene35
	BINARY "../bin/ene35c.bin"
		._ene36
	BINARY "../bin/ene36c.bin"
		._ene37
	BINARY "../bin/ene37c.bin"
		
	._ene_bonus
	BINARY "../bin/ene_bonusc.bin"
	
	
	
#endasm

// Define your level sequence array here:
// map_w, map_h, scr_ini, ini_x, ini_y, max_objs, 
// c_map_bolts, [c_tileset], c_enems_hotspots, c_behs, [c_sprites], [script], music_id
LEVEL levels [] = {
	{map_0, ene0},
	{map_1, ene1},
	{map_1a, ene1a},
	{map_2, ene2},
	{map_2a, ene2a},
	{map_5b, ene_bonus},
	{map_3, ene3},
	{map_4, ene4},
	{map_5, ene5},
	{map_6, ene6},
	{map_7, ene7},
	{map_8, ene8},
	{map_9, ene9},
	{map_10, ene10},
	{map_11, ene11},
	{map_12, ene12},
	{map_10b, ene_bonus},
	{map_13, ene13},
	{map_14, ene14},
	{map_15, ene15},
	{map_16, ene16},
	{map_17, ene17},
	{map_18, ene18},
	{map_19, ene19},
	{map_20, ene20},
	{map_21, ene21},
	{map_22, ene22},
	{map_20b, ene_bonus},
	{map_23, ene23},
	{map_24, ene24},
	{map_25, ene25},
	{map_26, ene26},
	{map_27, ene27},
	{map_28, ene28},
	{map_29, ene29},
	{map_30, ene30},
	{map_31, ene31},
	{map_32, ene32},
	{map_30b, ene_bonus},
	{map_33, ene33},
	{map_34, ene34},
	{map_35, ene35},
	{map_36, ene36},
	{map_37, ene37}


	
};


